import Row from "../types/Row";
import { RowId } from "../types/RowId";
/**
 * Get the row ID from a row using the specified accessor or fall back to index
 */
export declare const getRowId: (row: Row, index: number, rowIdAccessor?: string) => RowId;
/**
 * Get nested rows from a row based on the grouping path
 */
export declare const getNestedRows: (row: Row, groupingKey: string) => Row[];
/**
 * Check if a row has nested rows for a given grouping key
 */
export declare const hasNestedRows: (row: Row, groupingKey?: string) => boolean;
/**
 * Set the expansion state for a row (we'll need to track this separately now)
 */
export declare const setRowExpansion: (rows: Row[], targetRowId: RowId, isExpanded: boolean, rowIdAccessor?: string) => Row[];
/**
 * Check if a row is expanded (check our internal expansion state)
 */
export declare const isRowExpanded: (row: Row) => boolean;
/**
 * Flatten rows recursively based on row grouping configuration
 */
export declare const flattenRowsWithGrouping: (rows: Row[], rowGrouping?: string[], rowIdAccessor?: string, depth?: number, expandedRows?: Set<string>) => {
    row: Row;
    depth: number;
    groupingKey?: string | undefined;
}[];
